/*
 * Name: kstat syscalls.c
 * Date: Sat Aug 19 15:36:53 CEST 2000
 * Author: FuSyS [fusys@s0ftpj.org, fusys@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * MOJITO-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a mojito.
 *
 * Tested on: RedHat Linux 6.0, Slackware 7, Debian 2.1 i386
 */

#include "linux.h"

#define NR		191	

char *sysc[NR]={
"ni_syscall",
"exit","fork","read","write","open",
"close","waitpid", "creat","link","unlink",
"execve","chdir","time","mknod","chmod",
"lchown","ni_syscall","stat","lseek","getpid",
"mount","oldumount", "setuid","getuid","stime",
"ptrace","alarm","fstat","pause","utime",
"ni_syscall","ni_syscall","access","nice","ni_syscall",
"sync","kill","rename","mkdir","rmdir",
"dup","pipe","times","ni_syscall","brk",
"setgid","getgid","signal","geteuid","getegid",
"acct","umount","ni_syscall","ioctl","fcntl",
"ni_syscall","setpgid","ni_syscall","olduname","umask",
"chroot","ustat","dup2","getppid","getpgrp",
"setsid","sigaction","sgetmask","ssetmask","setreuid",
"setregid","sigsuspend","sigpending","sethostname","setrlimit",
"getrlimit","getrusage","gettimeofday","settimeofday","getgroups",
"setgroups","select","symlink","lstat","readlink",
"uselib","swapon","reboot","readdir","mmap",
"munmap","truncate","ftruncate","fchmod","fchown",
"getpriority","setpriority","ni_syscall","statfs","fstatfs",
"ioperm","socketcall","syslog","setitimer","getitimer",
"newstat","newlstat","newfstat","uname","iopl",
"vhangup","idle","vm86old","wait4","swapoff",
"sysinfo","ipc","fsync","sigreturn","clone",
"setdomainname","newuname","modify_ldt","adjtimex","mprotect",
"sigprocmask","create_module","init_module","delete_module","get_kernel_syms",
"quotactl","getpgid","fchdir","bdflush","sysfs",
"personality","ni_syscall","setfsuid","setfsgid","llseek",
"getdents","select","flock","msync","readv",
"writev","getsid","fdatasync","sysctl","mlock",
"munlock","mlockall","munlockall","sched_setparam","sched_getparam",
"sched_setscheduler","sched_getscheduler","sched_yeld"
,"sched_get_priority_max","sched_get_priority_min",
"sched_rr_get_interval","nanosleep","mremap","setresuid","getresuid",
"vm86","query_module","poll","nfsservctl","setresgid",
"getresgid","prctl","rt_sigreturn","rt_sigaction","rt_sigprocmask",
"rt_sigpending","rt_sigtimedwait","rt_sigqueueinfo","rt_sigsuspend","pread",
"pwrite","chown","getcwd","capget","capset",
"sigaltstack","sendfile","ni_syscall","ni_syscall","vfork"};

unsigned long find_smap_addr(char *syscall)
{
        FILE *fd;
        char buff[8192], call[50], addr[15];

        fd=fopen(SYSTEMMAP, "r");

	memset(&call, '\0', 50);
	memset(&addr, '\0', 15);
        strncat(call, "sys_", 4);
        strncat(call, syscall, strlen(syscall));
	strncat(call, "\n", 1);
        call[5+strlen(syscall)+1]='\0';
	while((fgets(buff, 8192, fd))!=NULL){
                if(strstr(buff, call)){
			if(!strcmp(buff+11, call)){
                       		strncat(addr, "0x", 2);
                       		strncat(addr, buff, 8);
                       		addr[11]='\0';
                       		return(strtoul(addr, NULL, 0));
			}
                }
        }
	return -1;
}

void show_syscalls()
{
	int kd, i;
	unsigned int kaddr;
	unsigned long kmem_call_table[NR], smapaddr;

	kaddr=find_kmem_offset(SYSCALL);
	kd=open(KMEM, O_RDONLY);
	if(kread(kd, (unsigned long)kaddr, &kmem_call_table, sizeof(kmem_call_table)) == -1) err("kread error");

	printf("SysCall                         Address");
	for(i=1; i < NR; i++)
		if(kmem_call_table[i]){
			printf("\nsys_%-22s%16p",
				sysc[i], (void*)kmem_call_table[i]);
			smapaddr=find_smap_addr(sysc[i]);
			if(kmem_call_table[i] != smapaddr && smapaddr!=0xffffffff)
				printf(" WARNING! Should be at %p",
					(void*)smapaddr);
		}

}
