/*
 * Name: kstat util.c
 * Date: Sat Aug 19 15:36:53 CEST 2000
 * Author: FuSyS [fusys@s0ftpj.org, fusys@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * MOJITO-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a mojito.
 *
 * Tested on: RedHat Linux 6.0, Slackware 7, Debian 2.1 i386
 */

#include "linux.h"

void uso(char *str)
{
	printf("\nUsage: %s [-i iff] [-P] [-p pid] [-M] [-m addr] [-s]\n\n", str);
	printf("-i\tiff may be specified as 'all' or as name (e.g. eth0)\n");
	printf("\tdisplays info about the queried interface\n\n");
	printf("-P\tdisplays all processes\n\n");
	printf("-p\tpid is the process id of the queried task\n\n");
	printf("-M\tdisplays the kernel's LKMs' linked list\n\n");
	printf("-m\taddr is the hex address of the queried module\n");
	printf("\tdisplays info about the module to be found at addr\n\n");
	printf("-s\tdisplays info about the system calls' table\n\n");
	printf("\n");
	exit(0);
}

void err(char *str)
{
	printf("%s\n", str);
	exit(-1);
}

char *ntoa(unsigned long ip) {
        static char buff[18];
        char *p;
        p = (char *) &ip;
        sprintf(buff, "%d.%d.%d.%d",
                (p[0] & 255), (p[1] & 255), (p[2] & 255), (p[3] & 255));
        return(buff);
}

