/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
	idea & code by vecna - vecna@s0ftpj.org - www.s0ftpj.org
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <stdarg.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <net/if_arp.h>
#include <net/if.h>
#include <net/route.h>
#include <sys/ioctl.h>

#include "ipfwc_kernel_headers.h"
#include <linux/netlink.h>

#define SET_REMOTE_SOURCE	0
#define SET_LOCAL_DEST		1

#define MAXDATA			8192

#define IO_IN   1       /* IO input */
#define IO_OUT  0       /* IO ouput */


struct vskopt
	{
	char *source;
	char *dest;
	int l_sport, h_sport;
	int l_dport, h_dport;	
	char *iface;
	int command;
	int proto;
	char io:1;
	char logging:1;
	};

struct netlinkhdr 
	{
        unsigned int len;
        unsigned int mark;
        char iface[IFNAMSIZ];
	};

struct ipkt
	{
	struct iphdr ip;
	char data[MAXDATA + 46];
	};

struct iipkt
	{
	struct iphdr  ip;
	struct icmphdr icmp;
	char data[MAXDATA];
	};

struct tipkt
	{
	struct iphdr  ip;
	struct tcphdr tcp;
	char data[MAXDATA];
	};

struct uipkt
	{
	struct iphdr  ip;
	struct udphdr udp;
	char data[MAXDATA];
	};

int set_vsk(struct vskopt *);

	/*
	take struct vskopt filled with selected propriety, return
	as set_vsk_param (is funcion called immediatly)
	*/

int set_vsk_param(char *, char *, int [], char *, int, int, int, int, int);

	/* 
	return datalink socket for read packet, take as argument:

	char * source and dest parsabel by setmaskaddr(),
	int port[] =  [1] low source [2] high source [3] low dest [4] high,
	char * interface name (eth0, ppp1 ecc...)
	int protocol, IPPROTO_TCP and other,
	int IO index, 0 if "input", other if "output",
	int cmd, IP_FW_INSERT, IP_FW_DELETE ...
	int f, special flag for enable logging, SYN check, maxsize check,
	int ivf, special inverted flag, for inverted applied rules.

	*/

int fill_fw(int [], char *, int, int, int, int, int);

	/*
	int port array pointer as explained in set_vsk_param
	char * interface device name,
	int protocol to deny,
	int chain, chanary type,
	int cmd, command.
	int f, flag
	int ivf, inverted flag, for most info ipfw(4), default 0, 0.

	this funcione is call from set_vsk() for fill ip_fwuser struct
	after setup of source/dest address/mask by separate function 

	function return -1 if error attemp
	*/

int setmaskaddr(char *, int);
	
	/*
	char *address, contains adderess, read example below in code,
	int, SET_REMOTE_SOURCE if passed source host, else SET_LOCAL_DEST.
	
	function return -1 if error attemp

	funcion setmaskaddr set 
	-	fw.ipfw.fw_smsk
	-	fw.ipfw.fw_src
	in_addr structures if ad second argumen is passed "remote",
	if is passed "local" sets
	-	fw.ipfw.fw_dmsk
	-	fw.ipfw.fw_dst
	in_addr struct.
	char *remote and char *local, is sometime:
	host.domain.com/24 (class A of host.domain.com) or
	aaa.bbb.ccc.ddd/0 (aaa.bbb.ccc.ddd address) or
	any.any.any.any/32 (anywhere) ecc... 
	*/

int make_dl_socket(char *);

	/*
	set PF_PACKET (ad descrived on packet(4) ) on device passed, 
	return datalink socket file descriptor, -1 if error.
	cam use normal SOCK_PACKET if defined "SOCKPKT"
	*/

int open_netlink(void);

	/*
	function for open netlink firewall fd
	*/

struct ipkt get_nl_packet(int);
	
	/*
	function for read packet from netlink device, packet is
	already checked ad check_packet.
	first argument is file descriptor give from open_netlink.
	*/

int get_offset(int, char *);
	
	/*
	get offset of device (size of datalink layer header),
	return -1 in device result unknow.
	*/

int check_packet(void *, int);

	/*
	check packet function provide to check packet recieved with
	comparison of ip_fw struct (declared as static on libvsk.c) for 
	check if is a packet that must to be blocked or can be resend 
	on loopback interface.
	function return 1 if packet is blocked, return 0 when
	packet don't make interest.
	second argument is protocol to use for comparation.
	*/

int resend(int, void *, struct sockaddr_in, int, char *, int);

	/*
	send packet over loopback interface for bypass filter when
	is recieved packet that my be ignored.
	1st argument is socket (RAW_SOCK)
	2st argument is packet (header + data).
	3rd argument is sockaddr_in struct.
	4th argument is size of packet to send.
	5th argument is used if you want force interface for 
	resend of packet. NULL if you want to use default.
	flag is passed to maniputlate_route
	*/

int manipulate_route(char *, int, int);
	
	/*
	this function is sometimes called by resend that check static
	flag (and call it only one time) and force route to "lo"
	interface for traffic direct to external interface when
	is filtered and sniffed
	second int argument if >< 0 ADD to routing table, if 0
	DEL from routing table, 
	third int flag is used for unset static flag if you must insert 
	more of one routing entry normally this funcion is called by 
	"resend" but for multiple or unusual thing can be call from 
	external and controlled with flag.
	*/

int work_entry(ip_chainlabel, struct ip_fwuser *, int);

	/*
	function for set struct before pass it to setsockopt()
	*/

int do_setsockopt(int, void *, int);

	/*
	create SOCK_RAW, IPPROTO_RAW and set firewall rules
	*/
