#define __KERNEL__
#define MODULE

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/socket.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/udp.h>
#include <net/tcp.h>
#include <linux/skbuff.h>
#include <linux/version.h>
#include <sys/syscall.h>
/*                                                                          *
 * test single protocol hack by vecna@s0ftpj.org                            *
 * example code for HKS work/article                                        *
 *                                                                          */

/* for replace sock->ops->sock_recvmsg and sock->ops->sock_sendmsg */
static int (* tcp_recv)(struct sock *, struct msghdr *, int, int, int, int *);
static int (* tcp_send)(struct sock *, struct msghdr *, int);

/* 
 * for
 * 547./usr/src/linux/net# grep sockfd_lookup /proc/ksyms
 * 548./usr/src/linux/net#
 * seek sockfd_lookup symbol also if isn't exported
 */
static struct socket *(* sockfd_lookup)(int, int *) =(void *)0xc0187b8c;
/*
 * 548./usr/src/linux/net# grep sockfd_lookup /boot/System.map
 * 00000000c0187b8c T sockfd_lookup
 * 549./usr/src/linux/net#
 *
 * address is retrived by grep :)
 */

static int (* sock_map_fd)(struct socket *) =(void *)0xc0187a28;
/*
 * the same things about sock_map_fd
 */

#define CODESIZE	7

static char inj_code[CODESIZE]=
        "\xb8\x00\x00\x00\x00"  /* movl $0, %eax adderess is memcopyed after */
	"\xff\xe0"              /* jmp  *%eax */
	;

/* address of sys_socket for copy into new code */
void *socket_sym =(void *)0xc01884f8;

/* backup of linux code at socket_sym address */
static char code_backup[CODESIZE];

static int tsph_recvmsg(struct sock *sk, struct msghdr *msg, 
			int len, int nonblock, int flags, int *addr_len)
	{
	int ret =tcp_recv(sk, msg, len, nonblock, flags, addr_len);

	printk(KERN_INFO "pkt tcp rcvd\n");

	return ret;
	}

static int tsph_sendmsg(struct sock *sk, struct msghdr *msg, int size)
	{
	printk(KERN_INFO "pkt tcp snd\n");

	return tcp_send(sk, msg, size);
	}

static int tsph_socket(int family, int type, int protocol)
	{
	/*
	 * this code is more or less the same of /usr/src/linux/net/socket.c
	 * because of schedule problem I've preferred work over this than
	 * call original sys_socket and work on socket after
	 */
	int ret;
	struct socket *sock;

	if((ret =sock_create(family, type, protocol, &sock)) < 0)
		goto out;

	if((ret =sock_map_fd(sock)) < 0)
		goto out_release;

out:
	if(sock->sk->prot && !strcmp(sock->sk->prot->name, "TCP"))
	        {

		if(sock->ops->sendmsg !=NULL)
			{
			if(tcp_recv ==NULL)
				tcp_recv =(void *)sock->ops->recvmsg;

			sock->ops->recvmsg =(void *)tsph_recvmsg;
			}
		if(sock->ops->recvmsg !=NULL)
			{
			if(tcp_send ==NULL)
				tcp_send =(void *)sock->ops->sendmsg;

			sock->ops->sendmsg =(void *)tsph_sendmsg;
			}
		}

	/* It may be already another descriptor 8) Not kernel problem. */
	return ret;

out_release:
	sock_release(sock);
	return ret;
	}

int init_module(void)
	{

	*(unsigned long *)&inj_code[1] =(unsigned long)tsph_socket;

	/* make 5 byte backup, for save code on kmem referred to socket_sym */
	memcpy(code_backup, socket_sym, CODESIZE);

	/* copy asm code with exactly address over normal socket symbol ptr */
	memcpy(socket_sym, inj_code, CODESIZE);

	return(0);
	}

void cleanup_module(void)
	{
	/* restore */
	memcpy(socket_sym, code_backup, CODESIZE);
	}
